#ifndef DVGA_H
#define DVGA_H

#include <vfs.h>
#include <lib/font.h>

#define VGA_FRAMEBUFFER 0xFF700000

enum vga_color {
	VGA_COLOR_BLACK = 0,
	VGA_COLOR_BLUE = 1,
	VGA_COLOR_GREEN = 2,
	VGA_COLOR_CYAN = 3,
	VGA_COLOR_RED = 4,
	VGA_COLOR_MAGENTA = 5,
	VGA_COLOR_BROWN = 6,
	VGA_COLOR_LIGHT_GREY = 7,
	VGA_COLOR_DARK_GREY = 8,
	VGA_COLOR_LIGHT_BLUE = 9,
	VGA_COLOR_LIGHT_GREEN = 10,
	VGA_COLOR_LIGHT_CYAN = 11,
	VGA_COLOR_LIGHT_RED = 12,
	VGA_COLOR_LIGHT_MAGENTA = 13,
	VGA_COLOR_LIGHT_BROWN = 14,
	VGA_COLOR_WHITE = 15,
};

void vga_init(
	uint32_t fb_paddr,
	uint32_t fb_width,
	uint32_t fb_height,
	uint32_t fb_pitch,
	uint8_t fb_bpp
);

uint32_t vga_get_fb();
uint32_t vga_get_width();
uint32_t vga_get_height();
uint32_t vga_get_pitch();
uint8_t vga_get_bpp();

uint32_t vga_write(vfs_node_t* node, uint32_t offset, uint32_t size, uint8_t* buf);

void vga_clear_scrn(uint32_t color);

#endif